=== debian/changelog ===
vulkan-validationlayers (1.4.335.0-2) unstable; urgency=medium

  [ Pino Toscano ]
  * Enable the build on all the architectures, as this source is generally
    portable, and upstream accepts ports:
    - switch the architecture of the binaries from linux-any to any
    - Wayland is still Linux-specific, so:
      - limit the libwayland-dev build dependency as linux-any
      - pass -DBUILD_WSI_WAYLAND_SUPPORT=OFF to cmake on non-Linux
        architectures to explicitly disable the Wayland integration

 -- Timo Aaltonen <tjaalton@debian.org>  Fri, 19 Dec 2025 08:27:28 +0200

vulkan-validationlayers (1.4.335.0-1) unstable; urgency=medium

  * New upstream release.
  * control: Bump build-deps.

 -- Timo Aaltonen <tjaalton@debian.org>  Thu, 18 Dec 2025 13:51:35 +0200
